/* David Litchfield */
/* Slightly modified by Laszlo Toth to rid of some warning messages with the function definitions */


/* Row Header Non-clustered Table - 3 bytes */
/* |---Flag byte---|---Lock byte---|--- Column Count---| */

/* Row Header clustered Table Member - 4 bytes */
/* |---Flag byte---|---Lock byte---|--- Column Count---|--- Cluster Key Index ---| */

/* Row Header Cluster Key - 19 bytes */
/* |---Flag byte---|---Lock byte---|--- Column Count---|--- curc (2 bytes)---|--- comc (2 bytes)---|-- Previous Key (6 bytes)--|-- Next Key (6 bytes)---|*/




/* These flag are for the "Flag Byte" of the "Row Header" */ 

#define ORAROWFL_N 1		/* Last column continues in next piece */
#define	ORAROWFL_P 2		/* First column continues from previous piece */
#define	ORAROWFL_L 4		/* Last data piece */
#define	ORAROWFL_F 8		/* First data piece */
#define ORAROWFL_D 16		/* Deleted */
#define	ORAROWFL_H 32		/* Head piece of row */
#define ORAROWFL_C 64		/* Cluster table member */
#define ORAROWFL_K 128		/* Cluster Key */

#define DUMPALL 1
#define SHOWDELETED 2
#define DUMPNOTVIAOFFSETS 3
#define SHOWDELETEDNOTVIAOFFSETS 4
#define DUMPSCNS 5

char *block_types[] = {"", 
"Undo segment header", 		/* 1 */
"Undo Data Block", 		/* 2 */
"Save Undo Header", 		/* 3 */
"Save Undo Data Block", 	/* 4 */
"Data Segment Header", 		/* 5 */
"KTB Managed Data Block", 	/* 6 */
"Temp Table Block", 		/* 7 */
"Sort Key", 			/* 8 */
"Sort Run", 			/* 9 */
"Segment Free List Block", 	/* 10 */
"Data File Header" };		/* 11 */

char *help_options = "\n\nOrablock v1.00 [beta]\n\n(c) David Litchfield\n(david@davidlitchfield.com)\n\n"
"-h (show help)\n"
"-f data_file (required)\n"
"-c column_template\n"
"-z block_size (default 8192)\n"
"-o object_id\n"
"-b block_number\n"
"-s seperator (default newline)\n"
"-a action\n\n"
"Actions are:\n"
"A DUMPALL\n"
"D SHOWDELETED\n"
"O DUMPNOTVIAOFFSETS\n"
"S SHOWDELETEDNOTVIAOFFSETS\n"
"C DUMPSCNS\n"
"\n";

int orablock();
int PrintColumns(unsigned char *row, unsigned int row_header_size);
int ProcessArguments(int argc, char *argv[]);
int ProcessRow(unsigned char *row, unsigned int *hsize);